package com.nisum.ascend.inventory.controller;

import com.nisum.ascend.inventory.dto.ProductDto;
import com.nisum.ascend.inventory.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.nisum.ascend.inventory.service.ProductService;
import reactor.core.publisher.Mono;
import org.springframework.beans.factory.annotation.Autowired;

import reactor.core.publisher.Flux;

@RestController
@RequestMapping("/api/products")
public class ProductController {
    @Autowired
    ProductService productService;

    @GetMapping("/{sku}")
    public ResponseEntity<Mono<ProductDto>> getProductBySku(@PathVariable String sku) {
        Mono<ProductDto> monoProd = productService.getProductBySku(sku);
        HttpStatus status = monoProd != null ? HttpStatus.OK : HttpStatus.NOT_FOUND;
        return new ResponseEntity<>(monoProd, status);
    }

    @GetMapping()
    public ResponseEntity<Flux<ProductDto>> getAllProducts() {
        return ResponseEntity.ok(productService.findAllProducts());
    }

//    @PutMapping("/{userId}")
//    public Mono<ResponseEntity<Product>> updateProduct(@PathVariable String sku, @RequestBody Product product){
//        return productService.updateProductBySku(sku,user)
//                .map(updatedProduct -> ResponseEntity.ok(updatedProduct))
//                .defaultIfEmpty(ResponseEntity.badRequest().build());
//    }


}
